#include "moduleArchiveInvoices.h"


void removeInvoices (GtkWidget *widget, xdfInvConnModule *conn_mod)
{
	PGresult *res;
	GString *string = g_string_new ("");
	xdfDialogMsgStruct msg_struct;

	extern GtkWidget *entry_invoice_number,
									 *entry_invoice_prefix,
									 *combo_kind_of_invoice;

	g_string_printf (string, "UPDATE invoices SET is_active=FALSE WHERE "
				" number='%s' and prefix_number='%s' and "
				" invoices_kind_id=(SELECT id FROM invoices_kind WHERE name = '%s');",
				ENTRY_GET_TEXT (entry_invoice_number), ENTRY_GET_TEXT (entry_invoice_prefix), ENTRY_GET_TEXT (combo_kind_of_invoice));

	res = xdfPQexec (conn_mod->conn, string->str);

  if (PQgetisnull (res, 0, 0)) {
		msg_struct.msg = g_string_new ("WÅ‚aÅ›nie usunÄ…Å‚em fakturÄ™ !! \n\n\t XdeFactor-ng");
	  msg_struct.type = GTK_MESSAGE_INFO;
	  xdfDialogMsg (&msg_struct);
	}
	
	g_string_free (string, TRUE);
}
void findInvoices (GtkWidget *widget, xdfInvConnModule *conn_mod)
{
  PGresult *res;
  GString *string = g_string_new ("");
	xdfDialogMsgStruct msg_struct;
	gchar *result[2][11];
	char nr[16];
	prices kwoty;
	double value_without_tax=0, value_with_tax=0, value_tax=0;

	int i;

	extern GtkWidget *entry_invoice_number,
		*entry_invoice_prefix,
	  	*combo_kind_of_invoice,
		*entry_company_name,
		*clist_archive_invoices,
		*entry_nip,
		*entry_value_without_tax,
		*entry_value_tax,
		*entry_nip,
		*entry_company_name,
		*entry_print_date,
		*entry_sell_date,
		*entry_place,
		*entry_kind_of_pay,
		*entry_term_of_pay,
		*entry_wz,
		*entry_order,
		*entry_people_get,
		*entry_people_print,
		*entry_value_with_tax,
		*clist_archive_invoices;
					

  g_string_printf (string, "SELECT invoices.id "
				" FROM invoices "
				" WHERE "
				"  invoices.prefix_number = '%s' and "
				"  invoices.is_active=TRUE and "
				"  invoices.number = '%s' and "
				"  invoices.invoices_kind_id=(SELECT id FROM invoices_kind WHERE name='%s');",
				ENTRY_GET_TEXT (entry_invoice_prefix), ENTRY_GET_TEXT(entry_invoice_number), ENTRY_GET_TEXT(combo_kind_of_invoice));

  res = xdfPQexec ( conn_mod->conn, string->str );

  if (!PQgetisnull (res, 0, 0)) {
		g_string_printf (string, "SELECT clients.nip, "
						" clients.name, "
						" invoices.place, "
						" invoices.print_date, "
						" invoices.sell_date, "
						" kinds_of_pay.name, "
						" invoices.term_of_pay, "
						" invoices.nr_wz, "
						" invoices.orders, "
						" invoices.people_get, "
						" users.fullname, "
						" invoices.id "
					" FROM "
						" invoices, clients, kinds_of_pay, users "
						" WHERE "
						" invoices.id = '%s' and "
						" invoices.clients_id=clients.id and "
						" invoices.kinds_of_pay=kinds_of_pay.id and "
						" invoices.users_id=users.id;",
						PQgetvalue (res, 0, 0));

		res = xdfPQexec (conn_mod->conn, string->str);

		ENTRY_SET_TEXT (entry_nip, PQgetvalue (res, 0, 0));													
		ENTRY_SET_TEXT (entry_company_name, PQgetvalue (res, 0, 1));								
		ENTRY_SET_TEXT (entry_place, PQgetvalue (res, 0, 2));
		ENTRY_SET_TEXT (entry_print_date, PQgetvalue (res, 0, 3));
		ENTRY_SET_TEXT (entry_sell_date, PQgetvalue (res, 0, 4));
		ENTRY_SET_TEXT (entry_kind_of_pay, PQgetvalue (res, 0, 5));
		ENTRY_SET_TEXT (entry_term_of_pay, PQgetvalue (res, 0, 6));
		ENTRY_SET_TEXT (entry_wz, PQgetvalue (res, 0, 7));
		ENTRY_SET_TEXT (entry_order, PQgetvalue (res, 0, 8));
		ENTRY_SET_TEXT (entry_people_get, PQgetvalue (res, 0, 9));
		ENTRY_SET_TEXT (entry_people_print, PQgetvalue (res, 0, 10));

g_string_printf (string, "SELECT goods.name, "
				" goods.sww, "
				" units.name, "
				" invoice_goods.quantity, "
				" goods_data.sell_price, "
				" discounts.discount, "
				" goods_data.tax_vat, "
				" states_of_goods.name "
			   " FROM "
	  			" invoice_goods, goods, units, goods_data, states_of_goods, discounts "
			   " WHERE "
				" goods.id=goods_data.goods_id and "
				" discounts.invoice_goods_id=invoice_goods.id and "
				" states_of_goods.id=goods.states_of_goods_id and "
				" goods.id=invoice_goods.goods_id and "
			/*	" goods_data.goods_id=goods.id and " */
				" goods_data.id=invoice_goods.goods_data_id and "
				" goods.units_id=units.id and "
				"  invoice_goods.invoices_id=(SELECT id FROM invoices WHERE number='%s' and is_active='TRUE' and prefix_number='%s' and invoices_kind_id=(SELECT id FROM invoices_kind WHERE name = '%s'));",
				ENTRY_GET_TEXT (entry_invoice_number), ENTRY_GET_TEXT (entry_invoice_prefix), ENTRY_GET_TEXT (combo_kind_of_invoice));

		res = xdfPQexec (conn_mod->conn, string->str);
		gtk_clist_clear (GTK_CLIST (clist_archive_invoices));		
		for (i=0; i < PQntuples (res); i++) {
			sprintf (nr, "%d", i+1);
			calcPrices(&kwoty, atof(PQgetvalue (res, i, 4)), atof(PQgetvalue (res, i, 3)), atoi(PQgetvalue (res, i, 6)), atoi(PQgetvalue (res, i, 5)));
			/* Lp */
			result[1][0] = strdup(nr);
			/* Nazwa Towaru */
			result[1][1] = PQgetvalue (res, i, 0);
			/* SWW */
			result[1][2] = PQgetvalue (res, i, 1);
			/* jm */
			result[1][3] = PQgetvalue (res, i, 2);
			/* Ilosc */
			result[1][4] = PQgetvalue (res, i, 3);
			/* Cena Netto */
			sprintf(nr, "%.2f", kwoty.cena_netto);
			result[1][5] = strdup(nr);
			/* Rabat */
			result[1][6] = PQgetvalue (res, i, 5);
			/* Wartosc netto */
			sprintf(nr, "%.2f", kwoty.wartosc_netto);
			result[1][7] = strdup(nr);
			/* stawka VAT */
			result[1][8] = PQgetvalue (res, i, 6);
			/* kwota VAT */
			sprintf(nr, "%.2f", kwoty.kwota_vat);
			result[1][9] = strdup(nr);
			/* wartosc brutto */
			sprintf(nr, "%.2f", kwoty.wartosc_brutto);
			result[1][10] = nr;

			value_without_tax += kwoty.wartosc_netto;
			value_with_tax += kwoty.wartosc_brutto;
			value_tax += kwoty.kwota_vat;

			gtk_clist_append (GTK_CLIST (clist_archive_invoices), result[1]);
			free(result[1][0]);
			free(result[1][5]);
			free(result[1][7]);
			free(result[1][9]);
		}
		
		g_string_printf (string, "%.2f", value_without_tax);
		ENTRY_SET_TEXT (entry_value_without_tax, string->str);

		g_string_printf (string, "%.2f", value_with_tax);
		ENTRY_SET_TEXT (entry_value_with_tax, string->str);
		
		g_string_printf (string, "%.2f", value_tax);
		ENTRY_SET_TEXT (entry_value_tax, string->str);

  	g_string_free (string, TRUE);
  }
	else {
		msg_struct.msg = g_string_new ("Nie ma takiej faktury!! \n\n\t XdeFactor-ng");
	  msg_struct.type = GTK_MESSAGE_WARNING;
	  xdfDialogMsg (&msg_struct);

		g_string_free (string, TRUE);
	}
}
