#include "../defs.h"

void createInvoiceTXT (xdfInvConnModule *conn_mod) 
{
  InvoiceTax invoice;
  PGresult *res[2], *res_gets;
  GString *query = g_string_new ("");
  GString *people= g_string_new ("");
  GString *tmp = g_string_new ("");
  FILE *fp;
  int a,b,c; // dla petli, TYLKO!!
  char option[256];
  int lp;
  char words[128];
  prices kwoty;
  extern GtkWidget *combo_kind_of_invoice;
  char buff[256];

  initTax (&invoice);

  chdir (getenv ("HOME"));
  fp = fopen (INVOICE_NAME_TXT, "w");

  /* 
   * Zmieniam kodowanie na LATIN2, dzieki czemu
   * wrzutki towarów o nazwach w polskich znakach
   * nie powoduja zmian w wydruku (rozchodzenie tabeli)
   */
  
   xdfPQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'LATIN2';");

   g_string_printf (query, "SELECT "
			     "invoices.place,"
			     "invoices.print_date,"
			     "invoices.sell_date,"
			     "clients.name,"
			     "clients.street,"
			     "clients.postal_code,"
			     "clients.city,"
			     "clients.nip,"
			     "kinds_of_pay.name,"
			     "(invoices.term_of_pay - invoices.sell_date),"
			     "invoices.term_of_pay,"
			     "invoices.orders,"
			     "invoices.nr_wz,"
			     "users.fullname,"
			     "invoices.people_get,"
			     "clients.discount "
			     "FROM invoices, kinds_of_pay, clients, users "
			     "WHERE "
			     "invoices.number='%s' and "
			     "invoices.kinds_of_pay=kinds_of_pay.id and "
			     "invoices.prefix_number='%s' and "
			     "users.id=invoices.users_id and "
			     "clients.id=invoices.clients_id and "
			     "invoices.is_active='TRUE'",
				/* kurna, archiwalne potrzebuja tych klientow! a sprawdzanie id wystarczy
				"clients.is_active='TRUE';", */
			     conn_mod->invoice_number->str,
			     conn_mod->invoice_prefix->str);

  res[0] =  xdfPQexec (conn_mod->conn, query->str);

	g_string_printf (query, "SELECT "
			     "clients.name,"
			     "clients.street,"
			     "clients.postal_code,"
			     "clients.city,"
			     "clients.nip "
			     "FROM clients, invoices "
			     "WHERE "
			     "invoices.number='%s' and "
			     "invoices.prefix_number='%s' and "
			     "clients.id=invoices.clients_gets_id and "
			     "invoices.is_active='TRUE'",
				/* kurna, archiwalne potrzebuja tych klientow! a sprawdzanie id wystarczy
				"clients.is_active='TRUE';", */
			     conn_mod->invoice_number->str,
			     conn_mod->invoice_prefix->str);
					 
	res_gets = xdfPQexec (conn_mod->conn, query->str);

  fputs("+", fp);
  for(a=1; a < 39; a++)
    fputs("-", fp);
  fputs("+", fp);
  fputs("\n", fp);
  for(b=1; b < 8; b++){
    fputs("|", fp);
    for(a=1; a < 39; a++)
    fputs(" ", fp);
    fputs("|", fp);
    for(c=1; c < 30; c++)
    fputs(" ", fp);
    switch (b){
      case 1: fputs("MIEJSCE WYSTAWIENIA : ", fp); 
	      fputs (PQgetvalue (res[0], 0, 0), fp);
	      break;
      case 2: fputs("DATA WYSTAWIENIA    : ", fp);
	      fputs (PQgetvalue (res[0], 0, 1), fp);
	      break;
      case 3: fputs("DATA SPRZEDA¯Y      : ",  fp);
	      fputs (PQgetvalue (res[0], 0, 2), fp);
	      break;
    }
    fputs("\n", fp);
  }
  fputs("+", fp);
  fputs("-", fp);
  fputs("-", fp);

  fputs("Pieczêæ firmy", fp);
  for(a=1; a < 24;a++)
    fputs("-", fp);
  fputs("+", fp);
  fputs("\n", fp);
  fputs("\n", fp);
  fputs("\n", fp);
	
  for(a=1; a < 41; a++)
    fputs(" ", fp);	
    fputs("[ O R Y G I N A £ / K O P I A ]", fp);
    fputs("\n", fp);
    fputs("\n", fp);
  
    g_string_printf (people, "%-80s%s", PQgetvalue (res[0], 0, 14), PQgetvalue (res[0], 0, 13));
    
  fputs ("\n", fp);
  fputs ("\n", fp);
  fputs ("SPRZEDAWCA\n", fp);
  
	sprintf(buff, "%s/%s", conf_params.conf_path, SPRZEDAWCA_CONF);
	search (buff, "nazwa_firmy", option);
	fputs (option, fp);
	fputs (" ", fp);
	search (buff, "wlasciciel", option);
	fputs (option, fp);
	fputs ("\n", fp);
	search (buff, "ulica", option);
	fputs ("ul. ", fp);
	fputs (option, fp);
	fputs ("\n", fp);
	search (buff, "kod_pocztowy", option);
	fputs (option, fp);
	fputs (" ", fp);
	search (buff, "miejscowosc", option);
	fputs (option, fp);
	fputs ("\n", fp);
	fputs ("NIP: ", fp);
	search (buff, "nip", option);
	fputs (option, fp);
	fputs ("\n", fp);
	fputs ("Tel: ", fp);
	search (buff, "telefon", option);
	fputs (option, fp);
	fputs ("\n", fp);
	fputs ("Fax: ", fp);
	search (buff, "fax", option);
	fputs (option, fp);
	fputs ("\n", fp);
	fputs ("Konto   : ", fp);
	search (buff, "bank", option);
	fputs (option, fp);
	fputs ("\n", fp);
	fputs ("Nr konta: ", fp);
	search (buff, "nr_konta", option);
	fputs (option, fp);
	fputs ("\n", fp);
  
    
  fputs ("\n", fp);
  fputs ("\n", fp);


  for (a=0; a < 38; a++)
    fputs (" ", fp);

  if (strcmp (ENTRY_GET_TEXT (combo_kind_of_invoice), "Faktura VAT") == 0)
    fputs ("F A K T U R A   V A T   N R : ", fp);
  else
    fputs ("F A K T U R A   V A T - P R O F O R M A   N R : ", fp);

    fputs (conn_mod->invoice_prefix->str, fp);
    fputs (conn_mod->invoice_number->str, fp);
    fputs ("\n", fp);

  fputs ("\n", fp);
  fputs ("\n", fp);


  fputs ("NABYWCA", fp);
  for (a=0; a < 56; a++)
    fputs (" ", fp);
  fputs ("ODBIORCA\n", fp);

	g_string_printf (tmp, 	"%s %s", 
													 PQgetvalue (res[0], 0, 5), 
													 PQgetvalue (res[0], 0, 6)); 
	//--
	
  g_string_printf (query, "%-62s %s\n", 
													 PQgetvalue (res[0], 0, 3), 
													 PQgetvalue (res_gets, 0, 0));
	fputs (query->str, fp);

  g_string_printf (query, "%-62s %s\n", 
													 PQgetvalue (res[0], 0, 4), 
													 PQgetvalue (res_gets, 0, 1));
	fputs (query->str, fp);

  g_string_printf (query, "%-62s %s %s\n", 
													 tmp->str,
													 PQgetvalue (res_gets, 0, 2),
													 PQgetvalue (res_gets, 0, 3));
	fputs (query->str, fp);

  g_string_printf (query, "NIP: %-57s NIP: %s\n", 
													 PQgetvalue (res[0], 0, 7), 
													 PQgetvalue (res_gets, 0, 4));
	fputs (query->str, fp);

    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    
    
  fputs ("Sposób zap³aty     : ", fp);
    fputs (PQgetvalue (res[0], 0, 8), fp);
    fputs (" ", fp);
    if (strcmp (PQgetvalue (res[0], 0, 8), "Przelew") == 0) {
      fputs (PQgetvalue (res[0], 0, 9), fp);
      fputs (" dni\n", fp);
    } else
      fputs ("\n", fp);

  fputs ("Termin zap³aty     : ", fp);
    fputs (PQgetvalue (res[0], 0, 10), fp);
    fputs ("\n", fp);

  fputs ("Nr zamówienia      : ", fp);
    fputs (PQgetvalue (res[0], 0, 11), fp);
    fputs ("\n", fp);

  fputs ("Nr dokumentu W-Z   : ", fp);
    fputs (PQgetvalue (res[0], 0, 12), fp);
    fputs ("\n", fp);

    
  fputs ("\n", fp);
  fputs ("\n", fp);
  fputs ("\n", fp);

  fputs ("+", fp);
  for (a=0; a < 109; a++)
    fputs ("=", fp);
  fputs ("+\n", fp);
  fputs("|  |                               |              |   |       | Cena    |Ra| Warto¶æ  |   | Kwota  | Warto¶æ  |\n", fp);
  fputs("|Lp|    Nazwa  towaru  / us³ugi    |     PKWiU    |jm | Ilo¶æ |jedn. bez|ba|   bez    |VAT|podatku | towaru z |\n", fp);
  fputs("|  |                               |              |   |       | podatku |t%| podatku  |[%]|        |podatkiem |\n", fp);
  fputs("+==|===============================|==============|===|=======|=========|==|==========|===|========|==========+\n", fp);			


  g_string_printf (query, "SELECT goods.name,"
				  "goods.sww,"
				  "units.name,"
				  "invoice_goods.quantity,"
				  "goods_data.sell_price,"
				  "goods_data.tax_vat,"
				  "states_of_goods.name,"
				  "discounts.discount "
				"FROM "
	   "invoice_goods, goods, units, goods_data, states_of_goods, discounts "
				"WHERE "
/* archiwalne faktury moga zawierac nieaktywne towary!
				"goods.is_active='TRUE' and " */
				  "discounts.invoice_goods_id=invoice_goods.id and "
				  "states_of_goods.id=goods.states_of_goods_id and "
				  "goods.id=invoice_goods.goods_id and "
			/*	" goods_data.goods_id=goods.id and " */
				" goods_data.id=invoice_goods.goods_data_id and "
				  "goods.units_id=units.id and "
  "invoice_goods.invoices_id=(SELECT id FROM invoices WHERE number='%s' and is_active='TRUE' and invoices_kind_id=(SELECT id FROM invoices_kind WHERE name = '%s'));",
				  conn_mod->invoice_number->str,
				  ENTRY_GET_TEXT (combo_kind_of_invoice));

  res[1] = xdfPQexec (conn_mod->conn, query->str);
 
  lp=0;

      
  for (a=0; a < PQntuples (res[1]); a++) {
    lp++;
    calcPrices(&kwoty, atof(PQgetvalue(res[1], a, 4)), atof(PQgetvalue(res[1], a, 3)), atoi(PQgetvalue(res[1], a, 5)), atoi(PQgetvalue(res[1], a, 7)));
    g_string_printf (query, "|%2.0d|", lp);
      fputs (query->str, fp);

    g_string_printf (query, "%-31s|", PQgetvalue (res[1], a, 0));
      fputs (query->str, fp);

    g_string_printf (query, "%14s|", PQgetvalue (res[1], a, 1));
      fputs (query->str, fp);

    g_string_printf (query, "%3s|", PQgetvalue (res[1], a, 2));
      fputs (query->str, fp);

    g_string_printf (query, "%7.2f|", atof (PQgetvalue (res[1], a, 3)));
      fputs (query->str, fp);

    g_string_printf (query, "%9.2f|", kwoty.cena_netto);
      fputs (query->str, fp);

    g_string_printf (query, "%2d|", atoi (PQgetvalue (res[1], a, 7)));
      fputs (query->str, fp);

    g_string_printf (query, "%10.2f|", kwoty.wartosc_netto);
    fputs (query->str, fp);
      
    if (strcmp ("bez podatku", PQgetvalue (res[1], a, 6)) == 0) {
      g_string_printf (query, "%3s|", "zw");
      addValueWithoutTax (-1, kwoty.wartosc_netto, &invoice);
      addValueWithTax (-1, kwoty.wartosc_brutto, &invoice);
    } else {
      g_string_printf (query, "%3s|", PQgetvalue (res[1], a, 5));
      addValueWithoutTax (atoi (PQgetvalue (res[1], a, 5)), kwoty.wartosc_netto, &invoice);
      addValueWithTax (atoi (PQgetvalue (res[1], a, 5)), kwoty.wartosc_brutto, &invoice);
    }
    fputs (query->str, fp);

    g_string_printf (query, "%8.2f|", kwoty.kwota_vat); 
      fputs (query->str, fp);

    g_string_printf (query, "%10.2f|", kwoty.wartosc_brutto);
      fputs (query->str, fp);


    fputs ("\n", fp);
  }


  fputs ("+", fp);
  for (a=0; a < 109; a++)
    fputs ("-", fp);
  fputs ("+", fp);
  fputs ("\n", fp);


  for (a=0; a < 69; a++)
    fputs (" ", fp);
  fputs ("RAZEM :", fp);
    g_string_printf (query, "%10.2f     ", getAllValueWithoutTax (&invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%8.2f ", getAllValueWithTax (&invoice) - getAllValueWithoutTax (&invoice)); 
    fputs (query->str, fp);
    g_string_printf (query, "%10.2f", getAllValueWithTax (&invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 60; a++)
    fputs (" ", fp);
  for (a=0; a < 51; a++)
    fputs ("-", fp);

  fputs ("\n", fp);

  for (a=0; a < 69; a++)
    fputs (" ", fp);
  fputs ("W TYM : ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (22, &invoice));
    fputs (query->str, fp);
    fputs ("  22 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (22, &invoice) - getValueWithoutTax (22, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (22, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (7, &invoice));
    fputs (query->str, fp);
    fputs ("   7 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (7, &invoice) - getValueWithoutTax (7, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (7, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (3, &invoice));
    fputs (query->str, fp);
    fputs ("   3 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (3, &invoice) - getValueWithoutTax (3, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (3, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (0, &invoice));
    fputs (query->str, fp);
    fputs ("   0 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (0, &invoice) - getValueWithoutTax (0, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (0, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (-1, &invoice));
    fputs (query->str, fp);
    fputs ("  zw ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (-1, &invoice) - getValueWithoutTax (-1, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (-1, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  fputs ("\n", fp);
  fputs ("\n", fp);
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
   search (buff, "info_text", option);
    fputs (option, fp);
  fputs ("\n", fp);
  fputs ("\n", fp);

  fputs ("DO ZAP£ATY:       ", fp);
    g_string_printf (query, "%12.2f z³", getAllValueWithTax (&invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);
    
    for(a=0; a < 112; a++)
      fputs ("=", fp);
    fputs ("\n", fp);
    inWords (getAllValueWithTax (&invoice), words);

    g_string_printf (query, "S£OWNIE : %s\n", words);
    fputs (query->str, fp);
    for(a=0; a < 112; a++)
      fputs ("=", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);

    fputs (people->str, fp);
    fputs ("\n", fp);
    for (a=0; a < 30; a++)
      fputs (".", fp);
    for (a=0; a < 50; a++)
      fputs (" ", fp);
    for (a=0; a < 30; a++)
      fputs (".", fp);
    fputs ("\n", fp);

    fputs ("Podpis osoby uprawnionej do", fp);
    for (a=0; a < 53; a++)
      fputs (" ", fp);
    fputs ("Podpis osoby uprawnionej do", fp);
    fputs ("\n", fp);
    fputs ("otrzymania faktury VAT", fp);
    for (a=0; a < 58; a++)
      fputs (" ", fp);
    fputs ("wystawienia faktury VAT", fp);
    

    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
	g_string_printf(query, "Wydruk wykonano w programie XdeFactor-ng %s (http://defactor-ng.gnu.pl)", VERSION);

    fputs (query->str, fp);
    
  /* Zamykam  plik */
  fclose (fp);
  /* Powracam znowu do UNICODU */
  xdfPQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'UNICODE';");

	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search (buff, "print_command", option);
  /* Tu mozna dorzucic rm */
  g_string_printf (query, "%s %s", option, INVOICE_NAME_TXT);
  system (query->str);

  g_string_free (query,  TRUE);
  g_string_free (tmp,  TRUE);
  g_string_free (people, TRUE);
  if(conn_mod->widget_destroy) gtk_widget_destroy (conn_mod->widget_destroy);
	
} 
