#ifndef __INVOICENUMBERS_H__
#define __INVOICENUMBERS_H__

/* Funkcja sprawdza czy faktura o danym numerze istnieje. */
gboolean invoiceNumberExists(xdfInvConnModule *conn_mod, gint number, gint year);

/* Funkcja zwraca następny numer faktury. */
gint getNextInvoiceNumber(xdfInvConnModule *conn_mod);

/* Funkcja ustawia numer faktury w invoiceNr.
   Zwraca ustawiony numer faktury. */
gint setInvoiceNumber(xdfInvConnModule *conn_mod, GString *invoiceNr);

/* Funkcja sprawdza poprawno?? numeru faktury w formularzu.
   Je?li numer faktury jest poprawny zwraca numer faktury.
   Je?li numer faktury jest niepoprawny to zwraca zero.
   o ile checkNumberIfExists jest TRUE.
   Je?li numer faktury jest poprawny, ju? jest w bazie faktur oraz
   checkNumberIfExists jest TRUE funkcja umieszcza
   nast?pny numer faktury w invoiceNr i go zwraca. */
gint validateInvoiceNumber(xdfInvConnModule *conn_mod, GString *invoiceNr,
	gboolean checkNumberIfExists, gint *year);


#endif
