#include "moduleGoods.h"

int modifyGoods (GString *string_no, xdfConnModule *conn_mod, int code_verify)
{
	GString *query = g_string_new ("query");
	GString *string_code = g_string_new ("code");
	GString *states;
	GString *kinds;
	ExecStatusType est[2];
	PGresult *res;
	int tax;
	double price;
	extern GtkWidget *combo_entry3,
		*checkbutton1,
		*combo_entry2,
		*entry_kod,
		*entry_state,
		*entry_bought,
		*entry_sell,
		*entry_name,
		*entry_mag,
		*entry_sww;

	price = fix5(xdfAtof(ENTRY_GET_TEXT(entry_sell)));
	g_string_printf(query, "%.2f", price);
	ENTRY_SET_TEXT(entry_sell, query->str); 
	price = fix5(xdfAtof(ENTRY_GET_TEXT(entry_bought)));
	g_string_printf(query, "%.2f", price);
	ENTRY_SET_TEXT(entry_bought, query->str); 

	if (code_verify == XDF_VERIFY_GOODS_ON) {
		g_string_printf(query, "SELECT " 
			" id "
			" FROM goods "
			" WHERE code='%s' "
			" and is_active='TRUE';",
			ENTRY_GET_TEXT(entry_kod));
		res = xdfPQexec(conn_mod->conn, query->str);
		if (PQresultStatus(res) == PGRES_TUPLES_OK && !PQgetisnull(res, 0, 0)) {
			PQclear(res);
			g_string_free(query, TRUE);
			g_string_free(string_code, TRUE);
			return XDF_VERIFY_UNSUCCESSFUL;
			}
		PQclear(res);
		} 

	if (!strcmp ("zw", ENTRY_GET_TEXT(combo_entry3))){  
		states = g_string_new("bez podatku");
		tax = 0;
		}
	else {
		states = g_string_new("z podatkiem");
		tax = atoi (ENTRY_GET_TEXT(combo_entry3));
		}
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton1)) == TRUE) {
		kinds = g_string_new("usługa");
		ENTRY_SET_TEXT(entry_mag, "1");
		ENTRY_SET_TEXT(entry_state, "0");
		}
	else
		kinds = g_string_new("towar");

	if (strcmp ("", ENTRY_GET_TEXT(entry_kod)) == 0)
		g_string_printf(string_code, "%s", "NULL");
	else
		g_string_printf(string_code, "\'%s\'",
			ENTRY_GET_TEXT(entry_kod));

	g_string_printf(query, "INSERT INTO goods ( "
		" code, "
		" name, "
		" sww, "
		" units_id, "
		" states_of_goods_id, "
		" stores_id, "
		" kinds_of_goods_id, "
		" creator_id ) "
		" VALUES "
		" (%s, "
		" '%s', "
		" '%s', "
		" (SELECT id FROM units WHERE memo='%s'), "
		" (SELECT id FROM states_of_goods WHERE name='%s'), "
		" '%s', "
		" (SELECT id FROM kinds_of_goods WHERE name='%s'),  "
		" %i);", 
		string_code->str, 
		ENTRY_GET_TEXT(entry_name), 
		ENTRY_GET_TEXT(entry_sww), 
		ENTRY_GET_TEXT(combo_entry2), 
		states->str, 
		ENTRY_GET_TEXT(entry_mag), 
		kinds->str, 
		conn_mod->userID); 

	res = xdfPQexec(conn_mod->conn, query->str);
	est[0] = PQresultStatus(res);
	PQclear(res);

	g_string_printf(query, "INSERT INTO goods_data ("
		"goods_id, no, store_state, bought_price, sell_price, tax_vat) "
		"VALUES ((SELECT MAX(id) FROM goods), %s,'%s','%s','%s','%d');",
		string_no->str,
		ENTRY_GET_TEXT(entry_state),
		ENTRY_GET_TEXT(entry_bought),
		ENTRY_GET_TEXT(entry_sell),
		tax);

	res = xdfPQexec(conn_mod->conn, query->str);
	est[1] = PQresultStatus(res);
	PQclear(res);

	g_string_free(query, TRUE);
	g_string_free(states, TRUE);
	g_string_free(kinds, TRUE);
	g_string_free(string_code, TRUE);

	if (est[0] == PGRES_COMMAND_OK && est[1] == PGRES_COMMAND_OK) {
		return XDF_VERIFY_OK;
		}
	else {
		return XDF_ADD_GOODS_UNSUCCESSFUL;
		}
}
