#include "moduleGoods.h"

void addStore(GtkWidget *widget, xdfConnModule *conn_mod)
{
	xdfDialogMsgStruct msg_struct;

	if (modifyStore(XDF_STORE_ADD, conn_mod) == XDF_SUCCESSFUL) {
		msg_struct.msg = g_string_new("Stan magazynu został zmieniony !! \n\n\t XdeFactor-ng");
		msg_struct.type = GTK_MESSAGE_INFO;
		}
	else {
		msg_struct.msg = g_string_new("NIE PODAŁEŚ ID TOWARU !!\n\n\t XdeFactor-ng");
		msg_struct.type = GTK_MESSAGE_WARNING;
		}
	xdfDialogMsg(&msg_struct);
	g_string_free(msg_struct.msg, TRUE);
}

void remStore(GtkWidget *widget, xdfConnModule *conn_mod)
{
	xdfDialogMsgStruct msg_struct;

	if (modifyStore(XDF_STORE_REM, conn_mod) == XDF_SUCCESSFUL) {
		msg_struct.type = GTK_MESSAGE_INFO;
		msg_struct.msg = g_string_new("Stan magazynu został zmieniony !! \n\n\t XdeFactor-ng");
		}
	else {
		msg_struct.msg = g_string_new("NIE PODALEŚ ID TOWARU \n LUB ZBYT DUŻO CHCESZ GO USUNĄĆ !!\n\n\t XdeFactor-ng");
		msg_struct.type = GTK_MESSAGE_WARNING;
		}
	xdfDialogMsg(&msg_struct);
	g_string_free(msg_struct.msg, TRUE);
}

void reStore(double quantity, xdfConnModule *conn_mod)
{
	GString *query = g_string_new("");
	extern GtkWidget *entry_search;

	g_string_printf(query, "UPDATE goods_data "
		" SET store_state = '%f' "
		" WHERE "
		" goods_data.no='%s' "
	        " and goods_data.goods_id=goods.id "
		" and goods.is_active='TRUE';",
		quantity,
		ENTRY_GET_TEXT(entry_search));

	PQclear(xdfPQexec(conn_mod->conn, query->str));
	g_string_free(query, TRUE);
}

int modifyStore(int kind_of_operation, xdfConnModule *conn_mod)
{
	extern GtkWidget *entry_mag_add_rem, *entry_search;
	double quantity;
	GString *query = g_string_new("");
	PGresult *res;

	quantity = 0;

	if (!(strcmp("", ENTRY_GET_TEXT(entry_search)))) {
		g_string_free(query, TRUE);
		return XDF_UNSUCCESSFUL;
		}

	g_string_printf(query, "SELECT store_state " 
		" FROM goods_data, goods "
		" WHERE "
		" goods_data.no='%s' "
		" and goods_data.goods_id=goods.id "
		" and goods.is_active='TRUE';", 
		ENTRY_GET_TEXT(entry_search));

	res = xdfPQexec(conn_mod->conn, query->str);
	quantity = atof(PQgetvalue(res, 0, 0));
	g_string_free(query, TRUE);
	PQclear(res);

	if ((kind_of_operation == XDF_STORE_ADD)
		&& (strcmp ("", ENTRY_GET_TEXT(entry_mag_add_rem)))) {
		quantity += atof(ENTRY_GET_TEXT(entry_mag_add_rem));
		reStore(quantity, conn_mod);
		return XDF_SUCCESSFUL;
		}
	else 
		if (quantity >= atof(ENTRY_GET_TEXT(entry_mag_add_rem))) {
			quantity -= atof(ENTRY_GET_TEXT(entry_mag_add_rem));
			reStore(quantity, conn_mod);
			return XDF_SUCCESSFUL;
			}
		else {
			return XDF_UNSUCCESSFUL;
			}
}
