#include "modulePreferences.h"
#include "loadPreferences.h"
#include "savePreferences.h"
#include "tabs.h"



void modulePreferences ( )
{
	GtkWidget *notebook;
	GtkWidget *frame;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *window;

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);

	g_signal_connect (G_OBJECT (window), "destroy", 
		    G_CALLBACK (gtk_widget_destroy),
		    GTK_WIDGET (window));

	gtk_window_set_title (GTK_WINDOW (window), "Ustawienia");

	/* Tworz tabel w ktr wrzucony bdzie cay notebook. */
	table = gtk_table_new (5, 3, FALSE);
	gtk_container_add (GTK_CONTAINER (window), table);

	/* Ustawiamy widget notebooka. */
  	notebook = gtk_notebook_new ();
	gtk_notebook_set_tab_pos ( GTK_NOTEBOOK(notebook) , GTK_POS_TOP);
	gtk_table_attach_defaults (GTK_TABLE (table), notebook, 0, 5, 0, 1);
	gtk_widget_show (notebook);

	/* Ustawiamy zakadki */
	frame = gtk_frame_new ("Program");
	gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
	gtk_widget_show (frame);
	gtk_container_add (GTK_CONTAINER (frame), tabXdeFactor_ng());
	label = gtk_label_new ("Program");
	gtk_notebook_prepend_page( GTK_NOTEBOOK (notebook), frame, label);
	
	frame = gtk_frame_new ("Sprzedawca");
	gtk_container_set_border_width (GTK_CONTAINER (frame), 10);
	gtk_widget_show (frame);
	gtk_container_add (GTK_CONTAINER (frame), tabSprzedawca());
	gtk_widget_show (label);
	label = gtk_label_new ("Sprzedawca");				
	gtk_notebook_prepend_page( GTK_NOTEBOOK(notebook), frame, label);
	
	/* Create a bunch of buttons */
	button = gtk_button_new_with_label ("zamknij");

	g_signal_connect_swapped (G_OBJECT (button), "clicked",
						 				G_CALLBACK (gtk_widget_destroy), G_OBJECT(window));
											

	gtk_table_attach_defaults (GTK_TABLE (table), button, 4, 5, 2, 3);

	gtk_widget_show (button);
						 
	button = gtk_button_new_with_label ("zapisz");
	
	/* 
	 * Przypisujemy strukture tab_preferences_entries do zmiennej tabs powizanej z obiektem.
	 * W tej zmiennej s wskaniki do widgetw na tabach notebooka wywietlanego.
	 */
	gtk_object_set_data(GTK_OBJECT(button), "tabs", &tab_preferences_entries);
	g_signal_connect (G_OBJECT (button), "clicked",
						 				G_CALLBACK (savePreferences), NULL);
	
	
	gtk_table_attach_defaults (GTK_TABLE (table), button, 2, 3, 2, 3);

	gtk_widget_show (button);
	
	/* button resetu/aduj, odczytuje na nowo preferencje uywane w programie. */
	button = gtk_button_new_with_label ("resetuj");
	gtk_object_set_data(GTK_OBJECT(button), "tabs", &tab_preferences_entries);
	g_signal_connect (G_OBJECT (button), "clicked",
						 				G_CALLBACK (loadPreferences), NULL);
	
	
	gtk_table_attach_defaults (GTK_TABLE (table), button, 0, 1, 2, 3);
	gtk_widget_show (button);
	
	gtk_widget_show (table);
	gtk_widget_show (window);

}

