#include <gtk/gtk.h>

#include "../../config.h"
#include "../../callbacks.h"

#ifndef __MODULE_PREFERENCES_H__
#define __MODULE_PREFERENCES_H__

void modulePreferences ();

typedef struct
{
GtkWidget	*entry_nazwa_firmy;
GtkWidget	*entry_wlasciciel;
GtkWidget	*entry_kod_pocztowy;
GtkWidget	*entry_miejscowosc;
GtkWidget	*entry_miejsce_wystawienia;
GtkWidget	*entry_telefon;
GtkWidget	*entry_fax;
GtkWidget	*entry_komorka;
GtkWidget	*entry_bank;
GtkWidget	*entry_nr_konta;
GtkWidget	*entry_ulica;
GtkWidget	*entry_nip;
} tabSprzedawcaEntries;


void	fillTabSprzedawcaEntries(tabSprzedawcaEntries tse, configData cd);
gint	saveTabSprzedawcaEntries(tabSprzedawcaEntries tse);


typedef struct
{
GtkWidget	*spin_button_invoices_clients_clist;
GtkWidget	*spin_button_invoices_goods_clist;
GtkWidget	*entry_prefix_nr_invoices;
GtkWidget	*menuitem_kind_of_nr_invoices_1;
GtkWidget	*menuitem_kind_of_nr_invoices_2;
GtkWidget	*menuitem_kind_of_nr_invoices_3;
GtkWidget	*optionmenu_kind_of_nr_invoices; /* by moe do usunicia */
GtkWidget	*entry_info_text;
GtkWidget	*entry_print_command;
GtkWidget	*radiobutton_print_format_ps;
GtkWidget	*radiobutton_print_format_ascii;
GtkWidget	*radiobutton_goods_prices_brutto;
GtkWidget	*radiobutton_goods_prices_netto;

} tabXdeFactor_ngEntries;

void	fillTabXdeFactor_ngEntries(tabXdeFactor_ngEntries *txnge, configData *cd);
gint	saveTabXdeFactor_ngEntries(tabXdeFactor_ngEntries *txnge);
					 
/*
 * Typ ktrym si posuguj do zapisywaniaczytania danych przy klikniciu
 * buttonw na zakadce "preferencje".
 */
typedef	struct {
	tabSprzedawcaEntries			tse;
	tabXdeFactor_ngEntries		txng;
} tabPreferencesEntries;

//tabSprzedawcaEntries *tse_;
//= {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
//tabXdeFactor_ngEntries *txdfe_;
//= {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

tabPreferencesEntries tab_preferences_entries;

void	fillPreferencesTab(tabPreferencesEntries *tpe, configData *cd);
gint	savePreferencesTab(tabPreferencesEntries *tpe);

extern configData conf_params;

#endif /* __MODULE_PREFERENCES__ */

