#include "callbacks.h"
#include "config.h"

PGconn *conn;
extern configData	conf_params;

int xdfConnSQL (xdfConnModule *conn_mod)
{
	gchar		*pgOptions=NULL, *pgTty=NULL, autologin[64];
	GString	*query = g_string_new ("query");
	PGresult	*res;
	gchar	buff[256];

	sprintf(buff, "%s/%s", conf_params.conf_path, DB_CONF);
	if(!(open (buff, O_WRONLY))){
		g_print ("\n Nie mog otworzy pliku %s\n", buff);
		exit (EXIT_FAILURE);
	}

	if ( conn_mod->kind_of_conn == 1){
		conn_mod->conn = PQsetdbLogin (	conf_params.db_host,
						  						conf_params.db_port,
												pgOptions, 
												pgTty, 
												conf_params.db_name,
												conf_params.db_user,
												conf_params.db_password);
    
		/* Sprawdz, czy polaczenie nastapilo poprawnie */
		if (PQstatus (conn_mod->conn) == CONNECTION_OK){
			xdfPQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'UNICODE';");
			xdfPQexec (conn_mod->conn, "SET DATESTYLE TO GERMAN;");
			sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
			search(buff, "autologin", autologin);
			if(!strcmp(autologin, "true")) {
				printf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
				search(buff, "ip", autologin);
				g_string_printf (query, "SELECT id FROM users WHERE name = '%s';", getpwuid(getuid())->pw_name);
				res = xdfPQexec (conn_mod->conn, query->str);
				if(PQntuples(res) != 1) return -1;
				g_string_printf (query, "UPDATE users SET ip='%s', interface='%s', is_logged_in='TRUE' WHERE name='%s';", autologin, "xdefactor-ng", getpwuid(getuid())->pw_name);
				xdfPQexec (conn_mod->conn, query->str);
				conn_mod->connect=0;
				conn_mod->userID=atoi(PQgetvalue (res, 0, 0));
			}
			conn=conn_mod->conn;
			return 0;
		}else
      return -1;
	}else{
      PQfinish (conn);
      return 0;
  }
}

