#include "../defs.h"

void calcPrices(prices *kwoty, double cena, double ilosc, int stawka_vat, int rabat) {
	char option[16];
	gchar	buff[256];

	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search (buff, "goods_prices", option);
	if(!strcmp(option, "brutto")) {
		kwoty->cena_brutto = cena;
		kwoty->cena_netto = fix5(kwoty->cena_brutto*(1 - ((double)stawka_vat)/(100+stawka_vat)));
		kwoty->wartosc_brutto = fix5(kwoty->cena_brutto*ilosc*(1 - rabat*0.01));
		kwoty->kwota_vat = fix5(kwoty->wartosc_brutto*(double)stawka_vat/(100+stawka_vat));
		kwoty->wartosc_netto = kwoty->wartosc_brutto - kwoty->kwota_vat;
	} else {
		kwoty->cena_netto = cena;
		kwoty->cena_brutto = fix5(cena*(100 + stawka_vat)/100);
		kwoty->wartosc_netto = fix5((kwoty->cena_netto)*ilosc*(1 - rabat*0.01));
		kwoty->kwota_vat = fix5 ((kwoty->wartosc_netto)*stawka_vat/100);
		kwoty->wartosc_brutto = fix5 (kwoty->wartosc_netto + kwoty->kwota_vat);
	}
	/*
printf("\n######\nDane:\n");
printf("cena: %.2f\n", cena);
printf("ilosc: %.2f\n", ilosc);
printf("stawka vat: %i\n", stawka_vat);
printf("rabat: %i\n", rabat);
printf("\n######\nWynik:\n");
printf("cena netto: %.2f\n", kwoty->cena_netto);
printf("cena brutto: %.2f\n", kwoty->cena_brutto);
printf("wartosc netto: %.2f\n", kwoty->wartosc_netto);
printf("wartosc brutto: %.2f\n", kwoty->wartosc_brutto);
printf("kwota vat: %.2f\n", kwoty->kwota_vat);
*/
}
