#include "../defs.h"

void psdefine(const char *what, const char *value, FILE *stream) {
	fprintf(stream, "/%s (%s) def\n", what, value);
}

void createInvoicePS (xdfInvConnModule *conn_mod) {
  InvoiceTax invoice;
  PGresult *res[2], *res_gets;
  GString *query = g_string_new ("");
  GString *people= g_string_new ("");
  GString *tmp = g_string_new ("");
  FILE *fp, *or;
  int a; // dla petli, TYLKO!!
  char option[256];
  prices kwoty;
  char words[128];
  extern GtkWidget *combo_kind_of_invoice;
  char buff[256];

  initTax (&invoice);

  chdir (getenv ("HOME"));
  fp = fopen (INVOICE_NAME_PS, "w");

	/* dodajê nag³ówkowy stuff */  
	if(!(or = fopen (INVOICE_ORIG_H, "r"))) {
      		printf("Nie aa  moge otworzyc %s\n", INVOICE_ORIG_H);
		exit(EXIT_FAILURE);
	}
	while (1) {
		size_t rd;
		rd = fread(option, 1, sizeof(option), or);
		fwrite(option, 1, rd, fp);
		if (rd != sizeof(option)) break;
	}
	fclose(or);

	/* opcjonalnie dodajê logo firmy - do dokoñczenia */  
	if((or = fopen (INVOICE_LOGO, "r"))) {
		while (1) {
			size_t rd;
			rd = fread(option, 1, sizeof(option), or);
			fwrite(option, 1, rd, fp);
			if (rd != sizeof(option)) break;
		}
		fputs("\n\n\n", fp);
		fclose(or);
	}
	else {
		fputs("/logo_data 10 string def\n"
			"/logo_width 0 def\n/logo_height 0 def\n"
			"/logo_bpp 0 def\n"
			"/logo_scale_x 0 def\n/logo_scale_y 0 def\n", fp);
	}
	/* opcjonalnie dodajê podpis i piecz±tkê wystawcy */  
	if((or = fopen (INVOICE_SIGN, "r"))) {
		while (1) {
			size_t rd;
			rd = fread(option, 1, sizeof(option), or);
			fwrite(option, 1, rd, fp);
			if (rd != sizeof(option)) break;
		}
		fputs("\n\n\n", fp);
		fclose(or);
	}
	else	{
		fputs("/sign_data 10 string def\n"
			"/sign_width 0 def\n/sign_height 0 def\n"
			"/sign_bpp 0 def\n"
			"/sign_scale_x 0 def\n/sign_scale_y 0 def\n", fp);
	}
  /* 
   * Zmieniam kodowanie na LATIN2, dzieki czemu
   * wrzutki towarów o nazwach w polskich znakach
   * nie powoduja zmian w wydruku (rozchodzenie tabeli)
   */
  
   xdfPQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'LATIN2';");

   g_string_printf (query, "SELECT "
			     "invoices.place,"
			     "invoices.print_date,"
			     "invoices.sell_date,"
			     "clients.name,"
			     "clients.street,"
			     "clients.postal_code,"
			     "clients.city,"
			     "clients.nip,"
			     "kinds_of_pay.name,"
			     "(invoices.term_of_pay - invoices.sell_date),"
			     "invoices.term_of_pay,"
			     "invoices.orders,"
			     "invoices.nr_wz,"
			     "users.fullname,"
			     "invoices.people_get,"
	  	     "clients.discount "
			     "FROM invoices, kinds_of_pay, clients, users "
			     "WHERE "
			     "invoices.number='%s' and "
			     "invoices.kinds_of_pay=kinds_of_pay.id and "
			     "invoices.prefix_number='%s' and "
			     "users.id=invoices.users_id and "
			     "clients.id=invoices.clients_id and "
			     "invoices.is_active='TRUE'",
/* kurna, archiwalne potrzebuja tych klientow! a sprawdzanie id wystarczy
			     "clients.is_active='TRUE';", */
			     conn_mod->invoice_number->str,
			     conn_mod->invoice_prefix->str);

  res[0] =  xdfPQexec (conn_mod->conn, query->str);

	g_string_printf (query, "SELECT "
			     "clients.name,"
 			     "clients.street,"
 			     "clients.postal_code,"
 			     "clients.city,"
 			     "clients.nip "
 			     "FROM clients, invoices "
 			     "WHERE "
 			     "invoices.number='%s' and "
 			     "invoices.prefix_number='%s' and "
 			     "clients.id=invoices.clients_gets_id and "
 			     "invoices.is_active='TRUE'",
/* kurna, archiwalne potrzebuja tych klientow! a sprawdzanie id wystarczy
			     "clients.is_active='TRUE';", */
			     conn_mod->invoice_number->str,
			     conn_mod->invoice_prefix->str);
					 
	res_gets = xdfPQexec (conn_mod->conn, query->str);

	psdefine("miejsce_wystawienia", PQgetvalue (res[0], 0, 0), fp);
	psdefine("data_wystawienia", PQgetvalue (res[0], 0, 1), fp);
	psdefine("data_sprzedazy", PQgetvalue (res[0], 0, 2), fp);
	
	sprintf(buff, "%s/%s", conf_params.conf_path, SPRZEDAWCA_CONF);
	search(buff, "nazwa_firmy", option);
	psdefine("s_nazwa", option, fp);
	search(buff, "wlasciciel", option);
	psdefine("s_wlasciciel", option, fp);
	search(buff, "ulica", option);
	psdefine("s_ulica", option, fp);
	search(buff, "kod_pocztowy", option);
	psdefine("s_kod_pocztowy", option, fp);
	search(buff, "miejscowosc", option);
	psdefine("s_miejscowosc", option, fp);
	search(buff, "nip", option);
	psdefine("s_nip", option, fp);
   search(buff, "telefon", option);
	psdefine("s_tel", option, fp);
	search(buff, "fax", option);
	psdefine("s_fax", option, fp);
	search (buff, "bank", option);
	psdefine("s_konto", option, fp);
	search(buff, "nr_konta", option);
	psdefine("s_nr_konta", option, fp);
	search(buff, "email", option);
	psdefine("s_email", option, fp);
	search(buff, "www", option);
	psdefine("s_www", option, fp);
	
	if(strcmp (ENTRY_GET_TEXT (combo_kind_of_invoice), "Faktura VAT") == 0)
		psdefine("tytul", "Faktura VAT", fp);
	else
		psdefine("tytul", "Faktura VAT - proforma", fp);
		
    	psdefine("fra_prefix", conn_mod->invoice_prefix->str, fp);
	psdefine("fra_numer", conn_mod->invoice_number->str, fp);
	
	psdefine("n_nazwa", PQgetvalue(res[0], 0, 3), fp);
	psdefine("n_ulica", PQgetvalue(res[0], 0, 4), fp);
	psdefine("n_kod_pocztowy", PQgetvalue(res[0], 0, 5), fp);
	psdefine("n_miejscowosc", PQgetvalue (res[0], 0, 6), fp);
	psdefine("n_nip", PQgetvalue (res[0], 0, 7), fp);

	psdefine("o_nazwa", PQgetvalue(res_gets, 0, 0), fp);
	psdefine("o_ulica", PQgetvalue(res_gets, 0, 1), fp);
	psdefine("o_kod_pocztowy", PQgetvalue (res_gets, 0, 2), fp);
	psdefine("o_miejscowosc", PQgetvalue (res_gets, 0, 3), fp);
	psdefine("o_nip", PQgetvalue (res_gets, 0, 4), fp);
	
	fputs("/sposob_zaplaty (", fp);
	fputs(PQgetvalue (res[0], 0, 8), fp);
	if(strcmp (PQgetvalue (res[0], 0, 8), "Przelew") == 0) fprintf(fp, " %s dni", PQgetvalue (res[0], 0, 9));
	fputs (") def\n", fp);

	psdefine("termin_zaplaty", PQgetvalue (res[0], 0, 10), fp);
	psdefine("nr_zamowienia", PQgetvalue (res[0], 0, 11), fp);
	psdefine("nr_wz", PQgetvalue (res[0], 0, 12), fp);
 	g_string_printf (query, "SELECT goods.name,"
 				"goods.sww,"
 				"units.name,"
 				"invoice_goods.quantity,"
 				"goods_data.sell_price,"
 				"goods_data.tax_vat,"
 				"states_of_goods.name,"
 				"discounts.discount "
 				"FROM "
 				"invoice_goods, goods, units, goods_data, states_of_goods, discounts "
 				"WHERE "
/* archiwalne faktury moga zawierac nieaktywne towary!
				"goods.is_active='TRUE' and " */
 				"discounts.invoice_goods_id=invoice_goods.id and "
 				"states_of_goods.id=goods.states_of_goods_id and "
 				"goods.id=invoice_goods.goods_id and "
			/*	" goods_data.goods_id=goods.id and " */
				" goods_data.id=invoice_goods.goods_data_id and "
 				"goods.units_id=units.id and "
 				"invoice_goods.invoices_id=(SELECT id FROM invoices WHERE number='%s' and is_active='TRUE' and invoices_kind_id=(SELECT id FROM invoices_kind WHERE name = '%s'));",
				conn_mod->invoice_number->str,
				ENTRY_GET_TEXT (combo_kind_of_invoice));

	res[1] = xdfPQexec (conn_mod->conn, query->str);
	printf("tupli: %i\n", PQntuples (res[1]));
	fputs("/poz_nazwy [", fp);
	for (a=0; a < PQntuples (res[1]); a++) fprintf(fp, "(%s) ", PQgetvalue (res[1], a, 0));
	fputs("] def\n",fp);
	
	fputs("/poz_pkwiu [", fp);
	for (a=0; a < PQntuples (res[1]); a++) fprintf(fp, "(%s) ", PQgetvalue (res[1], a, 1));
	fputs("] def\n",fp);
	
	fputs("/poz_jm [", fp);
	for (a=0; a < PQntuples (res[1]); a++) fprintf(fp, "(%s) ", PQgetvalue (res[1], a, 2));
	fputs("] def\n",fp);
	
	fputs("/poz_il [", fp);
	for (a=0; a < PQntuples (res[1]); a++) fprintf (fp, "(%7.2f) ", atof (PQgetvalue (res[1], a, 3)));
	fputs("] def\n",fp);
	
	fputs("/poz_cena_netto [", fp);
	for (a=0; a < PQntuples (res[1]); a++) {
		calcPrices(&kwoty, atof(PQgetvalue (res[1], a, 4)), atof(PQgetvalue (res[1], a, 3)), atoi(PQgetvalue (res[1], a, 5)), atoi(PQgetvalue (res[1], a, 7)));
		fprintf (fp, "(%9.2f) ", fix5 (kwoty.cena_netto));
	}
	fputs("] def\n",fp);
	
	fputs("/poz_rabat [", fp);
	for (a=0; a < PQntuples (res[1]); a++) fprintf (fp, "(%2d) ", (atoi (PQgetvalue (res[1], a, 7))));	
	fputs("] def\n",fp);
	
	fputs("/poz_wartosc_netto [", fp);
	for (a=0; a < PQntuples (res[1]); a++) {
		calcPrices(&kwoty, atof(PQgetvalue (res[1], a, 4)), atof(PQgetvalue (res[1], a, 3)), atoi(PQgetvalue (res[1], a, 5)), atoi(PQgetvalue (res[1], a, 7)));
		fprintf (fp, "(%10.2f) ", fix5 (kwoty.wartosc_netto));
	}
	fputs("] def\n",fp);

	fputs("/poz_vat [", fp);
	for (a=0; a < PQntuples (res[1]); a++) {
		calcPrices(&kwoty, atof(PQgetvalue (res[1], a, 4)), atof(PQgetvalue (res[1], a, 3)), atoi(PQgetvalue (res[1], a, 5)), atoi(PQgetvalue (res[1], a, 7)));
		if (strcmp ("bez podatku", PQgetvalue (res[1], a, 6)) == 0) {
			fputs("( zw) ", fp);
			addValueWithoutTax (-1, kwoty.wartosc_netto, &invoice);
			addValueWithTax (-1,  kwoty.wartosc_brutto, &invoice);
		} else {
			fprintf(fp, "(%3s) ", PQgetvalue (res[1], a, 5));
			addValueWithoutTax (atoi (PQgetvalue (res[1], a, 5)), kwoty.wartosc_netto, &invoice);
			addValueWithTax (atoi (PQgetvalue (res[1], a, 5)), kwoty.wartosc_brutto, &invoice);
		}
 	}
	fputs("] def\n", fp);

	fputs("/poz_kwota_vat [", fp);
	for (a=0; a < PQntuples (res[1]); a++) { 
			calcPrices(&kwoty, atof(PQgetvalue (res[1], a, 4)), atof(PQgetvalue (res[1], a, 3)), atoi(PQgetvalue (res[1], a, 5)), atoi(PQgetvalue (res[1], a, 7)));
			fprintf (fp, "(%8.2f) ", kwoty.kwota_vat);
	}
	fputs("] def\n", fp);

	fputs("/poz_kwota_brutto [", fp);
	for (a=0; a < PQntuples (res[1]); a++) {
		calcPrices(&kwoty, atof(PQgetvalue (res[1], a, 4)), atof(PQgetvalue (res[1], a, 3)), atoi(PQgetvalue (res[1], a, 5)), atoi(PQgetvalue (res[1], a, 7)));
		fprintf(fp, "(%10.2f) ", kwoty.wartosc_brutto);
	}
	fputs("] def\n", fp);

	g_string_printf (query, "%10.2f", fix5(getAllValueWithoutTax(&invoice)));
	psdefine("all_kwota_netto", query->str, fp);

	g_string_printf (query, "%8.2f", getAllValueWithTax(&invoice) - getAllValueWithoutTax(&invoice)); 
	psdefine("all_kwota_vat", query->str, fp);

	g_string_printf (query, "%10.2f", getAllValueWithTax (&invoice));
	psdefine("all_kwota_brutto", query->str, fp);

	fputs("/stawki_vat [( 22) (  7) (  3) (  0) ( zw)] def\n", fp);

	fputs("/all_vat_netto [(", fp);
	fprintf(fp, "%10.2f", getValueWithoutTax(22, &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithoutTax(7 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithoutTax(3 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithoutTax(0 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithoutTax(-1, &invoice));
	fputs(")] def\n", fp);

	fputs("/all_vat_war [(", fp);
	fprintf(fp, "%8.2f", getValueWithTax(22, &invoice) - getValueWithoutTax(22, &invoice));
	fputs(") (", fp);
	fprintf(fp, "%8.2f", getValueWithTax(7 , &invoice) - getValueWithoutTax(7 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%8.2f", getValueWithTax(3 , &invoice) - getValueWithoutTax(3 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%8.2f", getValueWithTax(0 , &invoice) - getValueWithoutTax(0 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%8.2f", getValueWithTax(-1, &invoice) - getValueWithoutTax(-1, &invoice));
	fputs(")] def\n", fp);

	fputs("/all_vat_brutto [(", fp);
	fprintf(fp, "%10.2f", getValueWithTax(22, &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithTax(7 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithTax(3 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithTax(0 , &invoice));
	fputs(") (", fp);
	fprintf(fp, "%10.2f", getValueWithTax(-1, &invoice));
	fputs(")] def\n", fp);

	option[0]='\0';
	
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search(buff, "info_text", option);
	psdefine("info_text", option, fp);
	g_string_printf (query, "%12.2f z", getAllValueWithTax(&invoice));
	psdefine("do_zaplaty", query->str, fp);

	inWords(getAllValueWithTax(&invoice), words);
	psdefine("slownie", words, fp);
	psdefine("wystawca", PQgetvalue (res[0], 0, 13), fp);
	psdefine("odbiorca", PQgetvalue (res[0], 0, 14), fp);
	g_string_printf(query, "Wydruk wykonano w programie XdeFactor-ng %s (http://defactor-ng.gnu.pl)", VERSION);
	psdefine("xd_footer", query->str, fp);
	fputs("\n\n\n", fp);
	
	/* dodajc waciw cz faktury */  
	if(!(or = fopen (INVOICE_ORIG_C, "r"))) {
      		printf("Nie moge otworzyc %s\n", INVOICE_ORIG_C);
		exit(EXIT_FAILURE);
	}
	while (1) {
		size_t rd;
		rd = fread(option, 1, sizeof(option), or);
		fwrite(option, 1, rd, fp);
		if (rd != sizeof(option)) break;
	}
	fclose(or);
	/* Zamykam  plik */
	fclose(fp);
	/* Powracam znowu do UNICODU */
	xdfPQexec(conn_mod->conn, "SET CLIENT_ENCODING TO 'UNICODE';");
	
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search (buff, "print_command", option);

	/* Tu mozna dorzucic rm */
	g_string_printf (query, "%s %s", option, INVOICE_NAME_PS);
	system (query->str);

	g_string_free (query,  TRUE);
	g_string_free (tmp, TRUE);
	g_string_free (people, TRUE);
	if(conn_mod->widget_destroy) gtk_widget_destroy (conn_mod->widget_destroy);
}
