#include "moduleGoods.h"

void addGoods ( GtkWidget *widget, xdfConnModule *conn_mod)
{
	GString *string_no = g_string_new ("start");
	GString *string_query	= g_string_new ("start");
	xdfDialogMsgStruct msg_struct;
	PGresult *res;

	msg_struct.title = g_string_new ("Raport operacji na towarach / usługach");

	res = xdfPQexec (conn_mod->conn, "SELECT MAX(id) FROM goods;");
	if (PQgetisnull (res, 0, 0))
		g_string_printf (string_no, "%d", 1);
	else
		g_string_printf (string_no, "(SELECT MAX(no)+1 FROM goods_data)");
	PQclear(res);

	if (modifyGoods (string_no, conn_mod, XDF_VERIFY_GOODS_ON) == 0){
		msg_struct.msg =
			g_string_new ("Właśnie dodałem towar / usługę \n\n\t XdeFactor-ng");
		msg_struct.type=GTK_MESSAGE_INFO;
		}
	else
		if (modifyGoods (string_no, conn_mod, XDF_VERIFY_GOODS_ON) == XDF_ADD_GOODS_UNSUCCESSFUL){
			msg_struct.msg =
				g_string_new ("DODANIE NOWEGO TOWARU / USŁUGI ZAKOŃCZYŁO SIĘ NIEPOWODZENIEM!! \n\n SPRAWDŹ CZY DOBRZE WYPEŁNILEŚ FORMULARZ \n\n\t XdeFactor-ng");
			msg_struct.type=GTK_MESSAGE_WARNING;
			}
		else
			if (modifyGoods (string_no, conn_mod, XDF_VERIFY_GOODS_ON) == XDF_VERIFY_UNSUCCESSFUL){
				msg_struct.msg =
					g_string_new ("TOWAR / USŁUGA O PODANYM KODZIE JUŻ ISTNIEJE !! \n\n UŻYJ INNEGO KODU LUB ZOSTAW PUSTE POLE !! \n\n\tXdeFactor-ng");
				msg_struct.type = GTK_MESSAGE_WARNING;
				}

	xdfDialogMsg (&msg_struct);
	g_string_free (string_no, TRUE);
	g_string_free (string_query, TRUE);
	g_string_free (msg_struct.msg, TRUE);
	g_string_free (msg_struct.title, TRUE);
}
