#include "moduleInvoices.h"

#define NR_LONG 10

char *reverse (char *text)
{
	char *new, *next;

	new = (char *)malloc(NR_LONG);
	next=new;

	text += 8; //tyle trzeba przeskoczyc znakow
	
	while (*text != '\0') 
		*(new++) = *(text++);

	*new='\0';
	
	return next;
}	
		
void nrInvoices (xdfInvConnModule *conn_mod, GString *string)
{
	struct tm *loctime;
	time_t curtime;
	char year[128];
	char year_[128];
	char prefix[128];
	extern GtkWidget *combo_kind_of_invoice;
	GString *query = g_string_new ("");
	long max_number;
	int a;
	PGresult *res;
	gchar	buff[256];
  

	curtime = time (NULL);
	loctime = localtime (&curtime);

	max_number = 0;

	/* 
   * Szukam prefixu faktury i dodaje go do numeru faktury.
   */
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search (buff, "prefix_nr_invoices", prefix);

	/* 
	 * Szukam rodzaju numerowania faktur.
	 */
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search (buff, "kind_of_nr_invoices", year_);
  
	if (strcmp ("NR/YYYY", year_) == 0) 
			  strftime (year, 128, "/%Y", loctime);

	if (strcmp ("NR/MM/YYYY", year_) == 0) 
			  strftime (year, 128, "/%m/%Y", loctime);
  
	if (strcmp ("YYYY/MM/NR", year_) == 0) 
			  strftime (year, 128, "%Y/%m/", loctime);
	
  /* 
   * Wyciagam z bazy danych najwiekszy numer faktury.
   * Jesli brak wpisu zaczynam od numeru 1, w przeciwnym wypadku sam 
	* znajduje kolejny numer.
   */
  g_string_printf (query,
		    " SELECT i.number " 
		    " FROM  invoices i, invoices_kind ik "
		    " WHERE "
		    " i.invoices_kind_id=ik.id and "
		    " ik.name='%s' and "
		    " i.is_active='TRUE' and "
		    " i.prefix_number = '%s' and "
		    " i.number LIKE '%%%s%%';",
		    ENTRY_GET_TEXT (combo_kind_of_invoice),
		    prefix, year);
  
	res = xdfPQexec (conn_mod->conn, query->str);


	if (PQgetisnull (res, 0, 0)) {
		if (strcmp ("YYYY/MM/NR", year_) == 0) {
			g_string_append (string, year);
			g_string_append (string, "1");
		}
		else g_string_append (string, "1");
	}else{
		for (a=0; a < PQntuples (res); a++) {
			if (strcmp ("YYYY/MM/NR", year_) == 0) {
				if (max_number < atol ( reverse (PQgetvalue (res, a, 0)))) 
					max_number = atol (reverse (PQgetvalue (res, a, 0)));
			}
			else
      	if (max_number < atol (PQgetvalue (res, a, 0)))
         	max_number = atol (PQgetvalue (res, a, 0));
      }
		
			if (strcmp ("YYYY/MM/NR", year_) == 0)
				g_string_append (string, year);
			sprintf (prefix, "%ld", ++max_number);
			g_string_append (string, prefix);
  	} 
		if (strcmp ("YYYY/MM/NR", year_) != 0) 
	 		g_string_append (string, year);
  
		g_string_free (query, TRUE);
}

