#include <string.h>
#include <stdio.h>

#include "moduleInvoices.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

void chan (GtkWidget *widget, xdfInvConnModule *conn_mod)
{
	extern GtkWidget *clist2, *entry8;
	conn_mod->widget = clist2;
	conn_mod->entry_search_nip=entry8;
	messagePrint (widget, conn_mod);
  timeoutAdd (conn_mod);
}
void reciveListInterface (GtkWidget *widget, xdfInvConnModule *conn_mod)
{
  GtkWidget *window;
  GtkWidget *fixed1;
  GtkWidget *frame1;
  GtkWidget *fixed2;
  GtkWidget *scrolledwindow2;
  GtkWidget *clist1;
  GtkWidget *label6;
  GtkWidget *label7;
  GtkWidget *button1;
  GtkWidget *frame2;
  GtkWidget *fixed3;
  GtkWidget *entry1;
  GtkWidget *button2;
  GtkWidget *label9;
  GtkWidget *label8;
  GtkWidget *label1;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "Odbiorca");
	gtk_widget_show (window);

  fixed1 = gtk_fixed_new ();
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window), fixed1);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_fixed_put (GTK_FIXED (fixed1), frame1, 8, 8);
  gtk_widget_set_size_request (frame1, 672, 456);

  fixed2 = gtk_fixed_new ();
  gtk_widget_show (fixed2);
  gtk_container_add (GTK_CONTAINER (frame1), fixed2);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_fixed_put (GTK_FIXED (fixed2), scrolledwindow2, 16, 8);
  gtk_widget_set_size_request (scrolledwindow2, 640, 336);

  clist1 = gtk_clist_new (2);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));

  label6 = gtk_label_new ("NIP");
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label6);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);

  label7 = gtk_label_new ("Nazwa firmy");
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label7);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  button1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button1);
  gtk_fixed_put (GTK_FIXED (fixed2), button1, 512, 368);
  gtk_widget_set_size_request (button1, 128, 56);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_fixed_put (GTK_FIXED (fixed2), frame2, 16, 360);
  gtk_widget_set_size_request (frame2, 368, 64);

  fixed3 = gtk_fixed_new ();
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (frame2), fixed3);

  entry1 = gtk_entry_new ();
  gtk_widget_show (entry1);
  gtk_fixed_put (GTK_FIXED (fixed3), entry1, 72, 8);
  gtk_widget_set_size_request (entry1, 158, 26);

  button2 = gtk_button_new_from_stock ("gtk-find");
  gtk_widget_show (button2);
  gtk_fixed_put (GTK_FIXED (fixed3), button2, 248, 0);
  gtk_widget_set_size_request (button2, 104, 40);

  label9 = gtk_label_new ("NIP");
  gtk_widget_show (label9);
  gtk_fixed_put (GTK_FIXED (fixed3), label9, 8, 8);
  gtk_widget_set_size_request (label9, 48, 24);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

  label8 = gtk_label_new ("Szukaj ");
  gtk_widget_show (label8);
  gtk_frame_set_label_widget (GTK_FRAME (frame2), label8);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

  label1 = gtk_label_new ("Lista odbiorców");
  gtk_widget_show (label1);
  gtk_frame_set_label_widget (GTK_FRAME (frame1), label1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

  g_signal_connect (G_OBJECT (clist1), "select_row", G_CALLBACK (selectionGetsClist), conn_mod);
  g_signal_connect (G_OBJECT (entry1), "activate", G_CALLBACK (searchClientsNip), conn_mod);
  gtk_signal_connect (GTK_OBJECT (button2), "clicked", GTK_SIGNAL_FUNC (searchClientsNip), conn_mod);
  g_signal_connect (G_OBJECT (button1), "clicked", G_CALLBACK (chan), conn_mod);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window, window, "window");
  GLADE_HOOKUP_OBJECT (window, fixed1, "fixed1");
  GLADE_HOOKUP_OBJECT (window, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (window, fixed2, "fixed2");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow2, "scrolledwindow2");
  GLADE_HOOKUP_OBJECT (window, clist1, "clist1");
  GLADE_HOOKUP_OBJECT (window, label6, "label6");
  GLADE_HOOKUP_OBJECT (window, label7, "label7");
  GLADE_HOOKUP_OBJECT (window, button1, "button1");
  GLADE_HOOKUP_OBJECT (window, frame2, "frame2");
  GLADE_HOOKUP_OBJECT (window, fixed3, "fixed3");
  GLADE_HOOKUP_OBJECT (window, entry1, "entry1");
  GLADE_HOOKUP_OBJECT (window, button2, "button2");
  GLADE_HOOKUP_OBJECT (window, label9, "label9");
  GLADE_HOOKUP_OBJECT (window, label8, "label8");
  GLADE_HOOKUP_OBJECT (window, label1, "label1");

	conn_mod->widget = clist1;
	conn_mod->entry_search_nip=entry1;
	conn_mod->widget_destroy = window;

  /* standardowo przy wlaczeniu modulu uaktualniam wszystkie listy */
  updateClientsClist (conn_mod); 

	searchClientsNip_Name (conn_mod);
}

