#include "moduleLogin.h"

GtkWidget *dialog1;

void moduleLogin (xdfConnModule *conn_mod)
{
  GtkWidget *dialog_vbox1;
  GtkWidget *fixed1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *entry_user;
  GtkWidget *entry_passwd;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  xdfDialogMsgStruct msg_struct;
	
  if (conn_mod->connect == -1){

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "Logowanie");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);
  gtk_window_resize (GTK_WINDOW (dialog1), 350, 150);
  gtk_window_set_position (GTK_WINDOW (dialog1), GTK_WIN_POS_CENTER);
  gtk_widget_show (dialog1);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), fixed1, TRUE, TRUE, 0);

  table1 = gtk_table_new (4, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_fixed_put (GTK_FIXED (fixed1), table1, 0, 0);
  gtk_widget_set_uposition (table1, 0, 0);
  gtk_widget_set_usize (table1, 323, 141);

  label1 = gtk_label_new ("\n         Nazwa użytkownika :     \n");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label2 = gtk_label_new ("\n    Hasło :\n");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  entry_user = gtk_entry_new ();
  gtk_widget_ref (entry_user);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "entry_user", entry_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_user);
  gtk_table_attach (GTK_TABLE (table1), entry_user, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);


  entry_passwd = gtk_entry_new ();
  gtk_widget_ref (entry_passwd);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "entry_passwd", entry_passwd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_passwd);
  gtk_table_attach (GTK_TABLE (table1), entry_passwd, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (entry_passwd), FALSE);
  gtk_entry_set_invisible_char (GTK_ENTRY (entry_passwd), '*');

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_from_stock (GTK_STOCK_OK);
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_ok);
  GTK_WIDGET_SET_FLAGS (button_ok, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked", 
		      GTK_SIGNAL_FUNC (xdfCheckPasswd),
		      conn_mod);

  button_cancel = gtk_button_new_from_stock (GTK_STOCK_CANCEL);
  gtk_widget_ref (button_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button_cancel", button_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_cancel);
  GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
  gtk_signal_connect_object (GTK_OBJECT(button_cancel), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),dialog1);

  gtk_object_set_data (GTK_OBJECT (button_ok), "user", entry_user);
  gtk_object_set_data (GTK_OBJECT (button_ok), "passwd", entry_passwd);

  }else{
    msg_struct.msg = g_string_new ("Najpierw wyloguj się !!\n\n \t XdeFactor-ng");
    msg_struct.type = GTK_MESSAGE_WARNING;
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.msg, TRUE);
  }  
}

int xdfCheckPasswd (GtkWidget *widget, xdfConnModule *conn_mod)
{
  PGresult	*res;
  GString	*pass_crypto;
  GtkWidget	*entry_user;
  GtkWidget	*entry_passwd;
  ExecStatusType est; 
  xdfDialogMsgStruct msg_struct;
  char ip[16];
  char md5_pass[33];
	gchar	buff[256];
  
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search(buff, "ip", ip);

  msg_struct.title = g_string_new ("RAPORT LOGOWANIA");
  
  pass_crypto  = g_string_new ("haslo_crypt");

  entry_user   = gtk_object_get_data (GTK_OBJECT (widget), "user");
  entry_passwd = gtk_object_get_data (GTK_OBJECT (widget), "passwd");
  
  xdfPQexec (conn_mod->conn, "BEGIN;");

  MD5SUM(md5_pass, ENTRY_GET_TEXT (entry_passwd));
  g_string_printf (pass_crypto, 
    "SELECT password, '%s',id FROM users WHERE name = '%s';", 
	md5_pass, ENTRY_GET_TEXT (entry_user));
  res = xdfPQexec (conn_mod->conn, pass_crypto->str);
  est = PQresultStatus (res);

  if ((strcmp (PQresStatus (est), "PGRES_COMMAND_OK") == 0 ||
       strcmp (PQresStatus (est), "PGRES_TUPLES_OK" ) == 0) &&
      PQntuples (res) != 0){

    if (PQgetisnull (res, 0, 0) == 0){
      if (strcasecmp (PQgetvalue (res, 0, 0), PQgetvalue (res, 0, 1)) == 0){
	msg_struct.msg = g_string_new ("Właśnie zalogowałeś się do systemu \n\n \t XdeFactor-ng");
	msg_struct.type = GTK_MESSAGE_INFO;
	/* Skoro pass_crypto juz nie bedziemy uzywac, wiec czemu nie skorzystac z niego :) */
	g_string_printf (pass_crypto, "UPDATE users SET ip='%s', interface='%s', is_logged_in='TRUE' WHERE name='%s';", ip, "xdefactor-ng", ENTRY_GET_TEXT (entry_user));
	xdfPQexec (conn_mod->conn, pass_crypto->str);
	conn_mod->connect=0;
	conn_mod->userID=atoi(PQgetvalue (res, 0, 2));
      }else{
	msg_struct.msg = g_string_new ("BŁĄD LOGOWANIA!! \n\n Źle wpisana nazwa użytkownika lub hasło. \n\n\t XdeFactor-ng");
	msg_struct.type = GTK_MESSAGE_WARNING;
	conn_mod->connect=-1;
      }
    }
  }else{
    msg_struct.msg = g_string_new ("BŁĄD LOGOWANIA!! \n\n Źle wpisana nazwa użytkownika, lub hasło. \n\n\t XdeFactor-ng");
    msg_struct.type = GTK_MESSAGE_WARNING;
    conn_mod->connect=-1;
  }
  
  xdfPQexec (conn_mod->conn, "COMMIT;");

  gtk_widget_destroy (GTK_WIDGET (dialog1));
  xdfDialogMsg (&msg_struct);
  g_string_free (msg_struct.msg, TRUE);
  g_string_free (pass_crypto, TRUE);


  return 0;
}
