#include "moduleLogout.h"

GtkWidget *window_main;

void logoutUser (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GString *string;
  xdfDialogMsgStruct msg_struct; 
  char ip[16];
	gchar	buff[256];
  
	sprintf(buff, "%s/%s", conf_params.conf_path, XDEFACTOR_CONF);
	search(buff, "ip", ip);
  string = g_string_new ("start");
  xdfPQexec(conn_mod->conn, "BEGIN;");
  g_string_printf (string, "UPDATE users SET is_logged_in='FALSE' WHERE interface='xdefactor-ng' and ip='%s';", ip);
  xdfPQexec (conn_mod->conn, string->str);
  msg_struct.msg = g_string_new ("Właśnie zostałeś wylogowany!!\n\n\t XdeFactor-ng");
  msg_struct.type = GTK_MESSAGE_INFO;
  xdfPQexec (conn_mod->conn, "COMMIT;");
  conn_mod->connect=-1;
  g_string_free (string, TRUE);

  xdfDialogMsg(&msg_struct);
  g_string_free (msg_struct.msg, TRUE);

}

void moduleLogout(xdfConnModule *conn_mod)
{
  xdfDialogMsgStruct msg_struct;
  GtkWidget *fixed1;
  GtkWidget *button_yes;
  GtkWidget *button_no;
  GtkWidget *label1;

  if (conn_mod->connect){
    msg_struct.msg = g_string_new ("Najpierw musisz zalogować się. \n\n\t XdeFactor-ng");
    msg_struct.type = GTK_MESSAGE_WARNING;
  	xdfDialogMsg(&msg_struct);
	  g_string_free (msg_struct.msg, TRUE);
	} else {
  window_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window_main), "window", window_main);
  gtk_window_set_title (GTK_WINDOW (window_main), "Wylogowanie XdeFactor-ng");
  gtk_window_set_position (GTK_WINDOW (window_main), GTK_WIN_POS_CENTER);
  gtk_window_resize (GTK_WINDOW (window_main), 300, 140);
  gtk_widget_show (window_main);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window_main), fixed1);

  button_yes = gtk_button_new_from_stock (GTK_STOCK_OK);
  gtk_widget_ref (button_yes);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "button_yes", button_yes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_yes);
  gtk_fixed_put (GTK_FIXED (fixed1), button_yes, 16, 84);
  gtk_widget_set_usize (button_yes, 120, 32);
  gtk_signal_connect(GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (logoutUser), conn_mod);
  gtk_signal_connect(GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);
  gtk_signal_connect_object (GTK_OBJECT (button_yes), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);

  button_no = gtk_button_new_from_stock (GTK_STOCK_NO);
  gtk_widget_ref (button_no);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "button_no", button_no,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_no);
  gtk_fixed_put (GTK_FIXED (fixed1), button_no, 168, 84);
  gtk_widget_set_usize (button_no, 120, 32);
  gtk_signal_connect_object (GTK_OBJECT (button_no), "clicked", GTK_SIGNAL_FUNC (gtk_widget_hide), window_main);

  label1 = gtk_label_new ("Czy na pewno chcesz wylogować się ?");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (window_main), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 24, 32);
  gtk_widget_set_uposition (label1, 24, 32);
  gtk_widget_set_usize (label1, 256, 32);
	}

}
