#include "tabs.h"

/**
 *
 * Funkcja dla moduu modulePreferences. Funckja wypeniajca zakadk 
 * z konfiguracj danych sprzedawcy.
 *
 */

GtkWidget *tabSprzedawca()
{
	GtkWidget *table;
	GtkWidget *entry;
	GtkWidget *label;


	
	table = gtk_table_new (4, 25, FALSE);
	gtk_table_set_col_spacings ( GTK_TABLE(table), 0);
	gtk_table_set_row_spacings ( GTK_TABLE(table), 2);
	gtk_container_set_border_width (GTK_CONTAINER (table), 10);

	/*
	 * Opcja nr 1
	 */
	label = gtk_label_new ("Nazwa firmy");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 0, 1);
	gtk_widget_show(label);

	entry = gtk_entry_new_with_max_length(50);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_nazwa_firmy));
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 0, 1);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_nazwa_firmy = entry;

	/*
	 * Opcja nr 2
	 */
	label = gtk_label_new ("Wlasciciel");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 2, 3);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(50);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_wlasciciel));
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 2, 3);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_wlasciciel = entry;


	/*
	 * Opcja nr 3 
	 */
	label = gtk_label_new ("Kod pocztowy");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 4, 5);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_kod_pocztowy));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 4, 5);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_kod_pocztowy = entry;

	/*
	 * Opcja nr 4 
	 */
	label = gtk_label_new ("Miejscowosc");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 6, 7);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_miejscowosc));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 6, 7);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_miejscowosc = entry;
	
	/*
	 * Opcja nr 5 
	 */
	label = gtk_label_new ("Miejsce wystawienia");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 8, 9);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_miejsce_wystawienia));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 8, 9);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_miejsce_wystawienia = entry;
	
	/*
	 * Opcja nr 6 
	 */
	label = gtk_label_new ("Telefon");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 10, 11);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_telefon));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 10, 11);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_telefon = entry;

	/*
	 * Opcja nr 7
	 */
	label = gtk_label_new ("Fax");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 12, 13);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_fax));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 12, 13);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_fax = entry;

	/*
	 * Opcja nr 8
	 */
	label = gtk_label_new ("Komorka");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 14, 15);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_komorka));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 14, 15);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_komorka = entry;

	/*
	 * Opcja nr 9
	 */
	label = gtk_label_new ("Nazwa banku");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 16, 17);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_bank));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 16, 17);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_bank = entry;

	/*
	 * Opcja nr 10
	 */
	label = gtk_label_new ("Numer konta");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 18, 19);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_nr_konta));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 18, 19);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_nr_konta = entry;

	/*
	 * Opcja nr 11
	 */
	label = gtk_label_new ("Ulica");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 20, 21);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_ulica));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 20, 21);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_ulica = entry;
	
	/*
	 * Opcja nr 12
	 */
	label = gtk_label_new ("NIP");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 22, 23);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(10);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.sp_nip));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 22, 23);
	gtk_widget_show(entry);
	tab_preferences_entries.tse.entry_nip = entry;


	/*
	 * Koniec opcji.
	 */
	gtk_widget_show(table);

	return table;
}

/**
 *
 * Funkcja dla moduu modulePreferences. Funckja wypeniajca zakadk 
 * z konfiguracj gwnych parametrw XdeFactor-ng.
 *
 */
GtkWidget *tabXdeFactor_ng()
{
	GtkWidget *table;
	GtkWidget *entry;
	GtkWidget *label;
	GtkWidget *spinbutton;
	GtkWidget *menuitem;
	GtkWidget *optionmenu;
	GtkWidget *menu;
	GtkWidget *radiobutton;
	GtkObject *adjustment;
	GSList		*group;

	table = gtk_table_new (4, 4, FALSE);

	/*
	 * Opcja nr 1
	 */
	label = gtk_label_new ("Odswiez. danych klienta (ms)");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 0, 1);
	gtk_container_set_border_width (GTK_CONTAINER (table), 10);
	gtk_widget_show(label);
	
	adjustment = gtk_adjustment_new (atoi(conf_params.xdf_invoices_clients_clist),
						 MIN_INVOICES_CLIST, MAX_INVOICES_CLIST, 1, 5, 5);
	spinbutton = gtk_spin_button_new(GTK_ADJUSTMENT (adjustment), 1, 0);
	gtk_table_attach_defaults (GTK_TABLE (table), spinbutton, 2, 3, 0, 1);
	gtk_widget_show(spinbutton);
	tab_preferences_entries.txng.spin_button_invoices_clients_clist = spinbutton;

	/*
	 * Opcja nr 2
	 */
	label = gtk_label_new ("Odswiez. listy towarow (ms)");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 2, 3);
	gtk_widget_show(label);
	
	adjustment = gtk_adjustment_new (atoi(conf_params.xdf_invoices_goods_clist), 
						 MIN_INVOICES_CLIST, MAX_INVOICES_CLIST, 1, 5, 5);
	spinbutton = gtk_spin_button_new(GTK_ADJUSTMENT (adjustment), 1, 0);
	gtk_table_attach_defaults (GTK_TABLE (table), spinbutton, 2, 3, 2, 3);
	gtk_widget_show(spinbutton);
	tab_preferences_entries.txng.spin_button_invoices_goods_clist = spinbutton;


	/*
	 * Opcja nr 3
	 */
	label = gtk_label_new ("Prefiks numeru faktury");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 4, 5);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(50);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.xdf_prefix_nr_invoices));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 4, 5);
	gtk_widget_show(entry);
	tab_preferences_entries.txng.entry_prefix_nr_invoices = entry;

	/*
	 * Opcja nr 4
	 */
	label = gtk_label_new ("Typ numerowania faktury");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 6, 7);
	gtk_widget_show(label);
	

	menu = gtk_menu_new();

	menuitem = gtk_menu_item_new_with_label("NR/YYYY");
	gtk_menu_prepend(menu, menuitem);
	gtk_widget_show(menuitem);
	tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_1 = menuitem;

	menuitem = gtk_menu_item_new_with_label("NR/MM/YYYY");
	gtk_menu_prepend(menu, menuitem);
	gtk_widget_show(menuitem);
	tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_2 = menuitem;

	menuitem = gtk_menu_item_new_with_label("YYYY/MM/NR");
	gtk_menu_prepend(menu, menuitem);
	gtk_widget_show(menuitem);
	tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_3 = menuitem;

	optionmenu = gtk_option_menu_new();
	gtk_option_menu_set_menu( GTK_OPTION_MENU(optionmenu), GTK_WIDGET (menu));
	gtk_table_attach_defaults (GTK_TABLE (table), optionmenu, 2, 3, 6, 7);
	gtk_widget_show(menu);
	gtk_widget_show(optionmenu);
	tab_preferences_entries.txng.optionmenu_kind_of_nr_invoices = optionmenu;
/*
	if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/YYYY"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu),
			GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_1));
	else if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/MM/YYYY"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu),
			GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_2));
	else if (g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"YYYY/MM/NR"))
		gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu),
			GTK_WIDGET(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_3));
*/		  
/*
	g_print("\n-%s-\n",conf_params.xdf_kind_of_nr_invoices);
	if (! g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/YYYY"))
		gtk_menu_item_activate(GTK_MENU_ITEM(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_1));
	else if (! g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"NR/MM/YYYY"))
		gtk_menu_item_activate(GTK_MENU_ITEM(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_2));
	else if (! g_strcasecmp(conf_params.xdf_kind_of_nr_invoices,"YYYY/MM/NR"))
		gtk_menu_item_activate(GTK_MENU_ITEM(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_3));
*/
	gtk_item_toggle(GTK_ITEM(tab_preferences_entries.txng.menuitem_kind_of_nr_invoices_2));

	/*
	 * Opcja nr 5
	 */
	label = gtk_label_new ("Tekst na fakturze");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 8, 9);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(50);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.xdf_info_text));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 8, 9);
	gtk_widget_show(entry);
	tab_preferences_entries.txng.entry_info_text = entry;


	/*
	 * Opcja nr 6
	 */
	label = gtk_label_new ("Polecenie drukowania");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 10, 11);
	gtk_widget_show(label);
	
	entry = gtk_entry_new_with_max_length(50);
	gtk_entry_set_text (GTK_ENTRY (entry), 
						 conv_to_utf8(conf_params.xdf_print_command));	
	gtk_table_attach_defaults (GTK_TABLE (table), entry, 2, 3, 10, 11);
	gtk_widget_show(entry);
	tab_preferences_entries.txng.entry_print_command = entry;

	/*
	 * Opcja nr 7
	 */
	label = gtk_label_new ("Typ wydruku");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 12, 13);
	gtk_widget_show(label);

	radiobutton = gtk_radio_button_new_with_label (NULL, "graficzny");
	gtk_table_attach_defaults (GTK_TABLE (table), radiobutton, 0, 1, 14, 15);
	if (g_strcasecmp(conf_params.xdf_print_format,"ps"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);
	gtk_widget_show (radiobutton);
	tab_preferences_entries.txng.radiobutton_print_format_ps = radiobutton;

	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));

	radiobutton = gtk_radio_button_new_with_label (group, "tekstowy");
	gtk_table_attach_defaults (GTK_TABLE (table), radiobutton, 2, 3, 14, 15);
	if (g_strcasecmp(conf_params.xdf_print_format,"txt"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);
   gtk_widget_show (radiobutton);
	tab_preferences_entries.txng.radiobutton_print_format_ascii = radiobutton;
											  

	/*
	 * Opcja nr 8
	 */
	label = gtk_label_new ("Typ cen");
	gtk_table_attach_defaults (GTK_TABLE (table), label, 0, 1, 16, 17);
	gtk_widget_show(label);

	radiobutton = gtk_radio_button_new_with_label (NULL, "brutto");
	gtk_table_attach_defaults (GTK_TABLE (table), radiobutton, 0, 1, 18, 19);
	if (g_strcasecmp(conf_params.xdf_goods_prices,"brutto"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);
	gtk_widget_show (radiobutton);
	tab_preferences_entries.txng.radiobutton_goods_prices_brutto = radiobutton;

	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
	
	radiobutton = gtk_radio_button_new_with_label (group, "netto");
	gtk_table_attach_defaults (GTK_TABLE (table), radiobutton, 2, 3, 18, 19);
	if (g_strcasecmp(conf_params.xdf_goods_prices,"netto"))
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), FALSE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton), TRUE);

	gtk_widget_show (radiobutton);
	tab_preferences_entries.txng.radiobutton_goods_prices_netto = radiobutton;

	/*
	 * Koniec opcji.
	 */
	gtk_widget_show(table);

	return table;
}

