#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <glib.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include "../common/defs.h"

#ifndef __MODULE_STORES_H_
#define __MODULE_STORES_H_

void moduleStores (xdfConnModule *conn_mod);

void findStoreId (GtkWidget *widget, xdfConnModule *conn_mod);

void findStoreName (GtkWidget *widget, xdfConnModule *conn_mod);

void addStore (GtkWidget *widget, xdfConnModule *conn_mod);

void cleanStore (GtkWidget *widget);

void updateStore (GtkWidget *widget, xdfConnModule *conn_mod);

void removeStore (GtkWidget *widget, xdfConnModule *conn_mod);

void showStoresClist (GtkWidget *widget, xdfConnModule *conn_mod);

void updateFromClist (char *text, xdfConnModule *conn_mod);

#endif /* __MODULE_STORES_H_ */
