#include "callbacks.h"

void xdfLog(FILE *fd, char *msg)
{
  struct tm *timeStruct;
  struct passwd *pwd;
  GString *string;
  glong curtime;

  string = g_string_new ("");
  pwd = getpwuid (getuid ());
  curtime = time (0);
  timeStruct = localtime (&curtime);

  fseek (fd, 0, SEEK_END);
  g_string_printf (string, "|%s|%s|%s|%s|\n", 
			    asctime (timeStruct),
			    msg,  
			    pwd->pw_name,
			    pwd->pw_gecos);
  fputs (string->str, fd);
  g_string_free (string, TRUE);
}
