#include "callbacks.h"

int xdfLogBehaviour (char *msg)
{
  int fd;
  struct tm *timeStruct;
  struct passwd *pwd;
  GString *string;
  glong curtime;

  string = g_string_new ("start");
  pwd = getpwuid (getuid ());
  curtime = time (0);
  timeStruct = localtime (&curtime);

  if ((fd = open (LOG_FILE, O_WRONLY))){
    lseek (fd, 0, SEEK_END);
    g_string_printf (string, "|%s|%s|%s|%s|\n", 
			    asctime (timeStruct),
			    msg,  
			    pwd->pw_name,
			    pwd->pw_gecos);

    write (fd, string->str, string->len);
    g_string_free (string, TRUE);
    return 0;
  }else{
    g_print ("\n Nie mogę otworzyć pliku: %s\n", LOG_FILE);
    return -1;
  }
  close (fd);
}
